#region Copyright And Revision History

/*---------------------------------------------------------------------------

	ListViewItemEx.cs
	Copyright  2003 Bill Menees.  All rights reserved.
	Bill@Menees.com

	Who		When		What
	-------	----------	-----------------------------------------------------
	BMenees	4.19.2003	Created.

-----------------------------------------------------------------------------*/

#endregion

using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace Menees
{
	public sealed class ListViewItemEx : ListViewItem
	{
		#region Public Members

		public int Indent
		{
			get
			{
				return m_iIndent;
			}
			set
			{
				if (m_iIndent != value)
				{
					m_iIndent = value;
					SetIndentation();
				}
			}
		}

		public void RefreshIndentation()
		{
			SetIndentation();
		}

		#endregion

		#region Private Methods

		private void SetIndentation()
		{
			Windows.SetListViewItemIndent(this, m_iIndent);
		}

		#endregion

		#region Private Data Members

		private int m_iIndent;

		#endregion
	}
}
