using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Menees;

namespace TestMenees
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl PageCtrl;
		private System.Windows.Forms.TabPage tabFileName;
		private System.Windows.Forms.Button btnFileName;
		private System.Windows.Forms.TextBox txtOutput;
		private System.Windows.Forms.TextBox txtFileName;
		private Menees.NumericTextBox numericTextBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.CheckBox chkInput;
		private System.Windows.Forms.CheckBox chkFloat;
		private System.Windows.Forms.CheckBox chkNegative;
		private Menees.NumericTextBox edtMin;
		private Menees.NumericTextBox edtMax;
		private System.Windows.Forms.OpenFileDialog OpenDlg;
		private System.Windows.Forms.SaveFileDialog SaveDlg;
		private System.Windows.Forms.TabPage tabEditor;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnNew;
		private System.Windows.Forms.Button btnTestTextEditor;
		private Menees.TextEditor Editor;
		private System.Windows.Forms.TabPage tabNumEdit;
		private System.Windows.Forms.Label lblCaret;
		private System.Windows.Forms.FontDialog FontDlg;
		private System.Windows.Forms.Button btnFont;
		private System.Windows.Forms.Button btnTabs;
		private Menees.FormSaver FormSave;
		private Menees.RecentItemList RecentFiles;
		private System.Windows.Forms.TabPage tabRecent;
		private System.Windows.Forms.Button btnUpdateRecentFiles;
		private Menees.TextEditor Files;
		private System.Windows.Forms.Panel pnlSide;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Button btnGetRecentFiles;
		private System.Windows.Forms.TabPage tabRichText;
		private Menees.RichTextBoxEx RichText;
		private System.Windows.Forms.Button btnTestRichText;
		private ContextMenuStrip RecentFilesContext;
		private MenuStrip menuStrip1;
		private ToolStripMenuItem mnuFile;
		private ToolStripMenuItem mnuRecentFiles;
		private ToolStripSeparator toolStripMenuItem1;
		private ToolStripMenuItem mnuExit;
		private ToolStripMenuItem mnuHelp;
		private ToolStripMenuItem mnuAbout;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			VisualStyles.MainForm = this;
			VisualStyles.EnableControls(this);

			chkInput.Checked = numericTextBox1.AllowAllInput;
			chkFloat.Checked = numericTextBox1.AllowFloat;
			chkNegative.Checked = numericTextBox1.AllowNegative;
			edtMin.Value = numericTextBox1.MinValue;
			edtMax.Value = numericTextBox1.MaxValue;
		}

		private void ResetText(string strMsg)
		{
			txtOutput.Text = "";
			WriteLine(strMsg);
		}

		private void WriteLine()
		{
			txtOutput.Text += "\r\n";
		}

		private void WriteLine(string s)
		{
			txtOutput.Text += s + "\r\n";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.PageCtrl = new System.Windows.Forms.TabControl();
			this.tabEditor = new System.Windows.Forms.TabPage();
			this.btnTabs = new System.Windows.Forms.Button();
			this.btnFont = new System.Windows.Forms.Button();
			this.lblCaret = new System.Windows.Forms.Label();
			this.btnTestTextEditor = new System.Windows.Forms.Button();
			this.btnNew = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.btnOpen = new System.Windows.Forms.Button();
			this.Editor = new Menees.TextEditor();
			this.OpenDlg = new System.Windows.Forms.OpenFileDialog();
			this.SaveDlg = new System.Windows.Forms.SaveFileDialog();
			this.tabFileName = new System.Windows.Forms.TabPage();
			this.btnFileName = new System.Windows.Forms.Button();
			this.txtFileName = new System.Windows.Forms.TextBox();
			this.tabNumEdit = new System.Windows.Forms.TabPage();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.edtMax = new Menees.NumericTextBox();
			this.edtMin = new Menees.NumericTextBox();
			this.chkNegative = new System.Windows.Forms.CheckBox();
			this.chkFloat = new System.Windows.Forms.CheckBox();
			this.chkInput = new System.Windows.Forms.CheckBox();
			this.numericTextBox1 = new Menees.NumericTextBox();
			this.tabRecent = new System.Windows.Forms.TabPage();
			this.RecentFilesContext = new System.Windows.Forms.ContextMenuStrip(this.components);
			this.btnGetRecentFiles = new System.Windows.Forms.Button();
			this.Files = new Menees.TextEditor();
			this.btnUpdateRecentFiles = new System.Windows.Forms.Button();
			this.tabRichText = new System.Windows.Forms.TabPage();
			this.btnTestRichText = new System.Windows.Forms.Button();
			this.RichText = new Menees.RichTextBoxEx();
			this.txtOutput = new System.Windows.Forms.TextBox();
			this.FontDlg = new System.Windows.Forms.FontDialog();
			this.FormSave = new Menees.FormSaver(this.components);
			this.RecentFiles = new Menees.RecentItemList(this.components);
			this.mnuRecentFiles = new System.Windows.Forms.ToolStripMenuItem();
			this.pnlSide = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.menuStrip1 = new System.Windows.Forms.MenuStrip();
			this.mnuFile = new System.Windows.Forms.ToolStripMenuItem();
			this.toolStripMenuItem1 = new System.Windows.Forms.ToolStripSeparator();
			this.mnuExit = new System.Windows.Forms.ToolStripMenuItem();
			this.mnuHelp = new System.Windows.Forms.ToolStripMenuItem();
			this.mnuAbout = new System.Windows.Forms.ToolStripMenuItem();
			this.PageCtrl.SuspendLayout();
			this.tabEditor.SuspendLayout();
			this.tabFileName.SuspendLayout();
			this.tabNumEdit.SuspendLayout();
			this.tabRecent.SuspendLayout();
			this.tabRichText.SuspendLayout();
			this.pnlSide.SuspendLayout();
			this.menuStrip1.SuspendLayout();
			this.SuspendLayout();
			// 
			// PageCtrl
			// 
			this.PageCtrl.Controls.Add(this.tabEditor);
			this.PageCtrl.Controls.Add(this.tabFileName);
			this.PageCtrl.Controls.Add(this.tabNumEdit);
			this.PageCtrl.Controls.Add(this.tabRecent);
			this.PageCtrl.Controls.Add(this.tabRichText);
			this.PageCtrl.Dock = System.Windows.Forms.DockStyle.Top;
			this.PageCtrl.Location = new System.Drawing.Point(0, 0);
			this.PageCtrl.Name = "PageCtrl";
			this.PageCtrl.SelectedIndex = 0;
			this.PageCtrl.Size = new System.Drawing.Size(440, 190);
			this.PageCtrl.TabIndex = 2;
			// 
			// tabEditor
			// 
			this.tabEditor.Controls.Add(this.btnTabs);
			this.tabEditor.Controls.Add(this.btnFont);
			this.tabEditor.Controls.Add(this.lblCaret);
			this.tabEditor.Controls.Add(this.btnTestTextEditor);
			this.tabEditor.Controls.Add(this.btnNew);
			this.tabEditor.Controls.Add(this.btnSave);
			this.tabEditor.Controls.Add(this.btnOpen);
			this.tabEditor.Controls.Add(this.Editor);
			this.tabEditor.Location = new System.Drawing.Point(4, 22);
			this.tabEditor.Name = "tabEditor";
			this.tabEditor.Size = new System.Drawing.Size(432, 164);
			this.tabEditor.TabIndex = 3;
			this.tabEditor.Text = "TextEditor";
			// 
			// btnTabs
			// 
			this.btnTabs.Location = new System.Drawing.Point(10, 135);
			this.btnTabs.Name = "btnTabs";
			this.btnTabs.Size = new System.Drawing.Size(60, 18);
			this.btnTabs.TabIndex = 7;
			this.btnTabs.Text = "T&abs";
			this.btnTabs.Click += new System.EventHandler(this.btnTabs_Click);
			// 
			// btnFont
			// 
			this.btnFont.Location = new System.Drawing.Point(10, 115);
			this.btnFont.Name = "btnFont";
			this.btnFont.Size = new System.Drawing.Size(60, 18);
			this.btnFont.TabIndex = 6;
			this.btnFont.Text = "&Font";
			this.btnFont.Click += new System.EventHandler(this.btnFont_Click);
			// 
			// lblCaret
			// 
			this.lblCaret.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblCaret.Location = new System.Drawing.Point(15, 5);
			this.lblCaret.Name = "lblCaret";
			this.lblCaret.Size = new System.Drawing.Size(50, 23);
			this.lblCaret.TabIndex = 5;
			this.lblCaret.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnTestTextEditor
			// 
			this.btnTestTextEditor.Location = new System.Drawing.Point(10, 95);
			this.btnTestTextEditor.Name = "btnTestTextEditor";
			this.btnTestTextEditor.Size = new System.Drawing.Size(60, 18);
			this.btnTestTextEditor.TabIndex = 4;
			this.btnTestTextEditor.Text = "&Test";
			this.btnTestTextEditor.Click += new System.EventHandler(this.btnTestTextEditor_Click);
			// 
			// btnNew
			// 
			this.btnNew.Location = new System.Drawing.Point(10, 75);
			this.btnNew.Name = "btnNew";
			this.btnNew.Size = new System.Drawing.Size(60, 18);
			this.btnNew.TabIndex = 3;
			this.btnNew.Text = "&New";
			this.btnNew.Click += new System.EventHandler(this.btnNew_Click);
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(10, 55);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(60, 18);
			this.btnSave.TabIndex = 2;
			this.btnSave.Text = "&Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// btnOpen
			// 
			this.btnOpen.Location = new System.Drawing.Point(10, 35);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.Size = new System.Drawing.Size(60, 18);
			this.btnOpen.TabIndex = 1;
			this.btnOpen.Text = "&Open";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// Editor
			// 
			this.Editor.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
						| System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.Editor.FileName = "";
			this.Editor.Font = new System.Drawing.Font("Courier New", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.Editor.Location = new System.Drawing.Point(80, 5);
			this.Editor.Name = "Editor";
			this.Editor.OpenFileDialog = this.OpenDlg;
			this.Editor.SaveFileDialog = this.SaveDlg;
			this.Editor.Size = new System.Drawing.Size(348, 155);
			this.Editor.TabIndex = 0;
			this.Editor.CaretMoved += new Menees.CaretMovedEventHandler(this.Editor_CaretMoved);
			// 
			// OpenDlg
			// 
			this.OpenDlg.DefaultExt = "txt";
			this.OpenDlg.Filter = "Text Files|*.txt|All Files|*.*";
			this.OpenDlg.Title = "Open File";
			// 
			// SaveDlg
			// 
			this.SaveDlg.DefaultExt = "txt";
			this.SaveDlg.Filter = "Text Files|*.txt|All Files|*.*";
			// 
			// tabFileName
			// 
			this.tabFileName.Controls.Add(this.btnFileName);
			this.tabFileName.Controls.Add(this.txtFileName);
			this.tabFileName.Location = new System.Drawing.Point(4, 22);
			this.tabFileName.Name = "tabFileName";
			this.tabFileName.Size = new System.Drawing.Size(432, 164);
			this.tabFileName.TabIndex = 2;
			this.tabFileName.Text = "FileName";
			// 
			// btnFileName
			// 
			this.btnFileName.Location = new System.Drawing.Point(15, 50);
			this.btnFileName.Name = "btnFileName";
			this.btnFileName.Size = new System.Drawing.Size(75, 23);
			this.btnFileName.TabIndex = 1;
			this.btnFileName.Text = "Test";
			this.btnFileName.Click += new System.EventHandler(this.btnFileName_Click);
			// 
			// txtFileName
			// 
			this.txtFileName.Location = new System.Drawing.Point(15, 20);
			this.txtFileName.Name = "txtFileName";
			this.txtFileName.Size = new System.Drawing.Size(235, 20);
			this.txtFileName.TabIndex = 0;
			this.txtFileName.Text = "C:\\Windows\\System32\\Notepad.Exe";
			// 
			// tabNumEdit
			// 
			this.tabNumEdit.Controls.Add(this.label2);
			this.tabNumEdit.Controls.Add(this.label1);
			this.tabNumEdit.Controls.Add(this.edtMax);
			this.tabNumEdit.Controls.Add(this.edtMin);
			this.tabNumEdit.Controls.Add(this.chkNegative);
			this.tabNumEdit.Controls.Add(this.chkFloat);
			this.tabNumEdit.Controls.Add(this.chkInput);
			this.tabNumEdit.Controls.Add(this.numericTextBox1);
			this.tabNumEdit.Location = new System.Drawing.Point(4, 22);
			this.tabNumEdit.Name = "tabNumEdit";
			this.tabNumEdit.Size = new System.Drawing.Size(432, 164);
			this.tabNumEdit.TabIndex = 0;
			this.tabNumEdit.Text = "NumEdit";
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(135, 72);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(30, 13);
			this.label2.TabIndex = 8;
			this.label2.Text = "Max:";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(135, 42);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(27, 13);
			this.label1.TabIndex = 7;
			this.label1.Text = "Min:";
			// 
			// edtMax
			// 
			this.edtMax.Location = new System.Drawing.Point(175, 70);
			this.edtMax.Name = "edtMax";
			this.edtMax.Size = new System.Drawing.Size(100, 20);
			this.edtMax.TabIndex = 6;
			this.edtMax.Text = "0";
			this.edtMax.Validated += new System.EventHandler(this.edtMax_Validated);
			// 
			// edtMin
			// 
			this.edtMin.Location = new System.Drawing.Point(175, 40);
			this.edtMin.Name = "edtMin";
			this.edtMin.Size = new System.Drawing.Size(100, 20);
			this.edtMin.TabIndex = 5;
			this.edtMin.Text = "0";
			this.edtMin.Validated += new System.EventHandler(this.edtMin_Validated);
			// 
			// chkNegative
			// 
			this.chkNegative.Location = new System.Drawing.Point(20, 75);
			this.chkNegative.Name = "chkNegative";
			this.chkNegative.Size = new System.Drawing.Size(104, 24);
			this.chkNegative.TabIndex = 4;
			this.chkNegative.Text = "Allow Negative";
			this.chkNegative.CheckedChanged += new System.EventHandler(this.chkNegative_CheckedChanged);
			// 
			// chkFloat
			// 
			this.chkFloat.Location = new System.Drawing.Point(20, 55);
			this.chkFloat.Name = "chkFloat";
			this.chkFloat.Size = new System.Drawing.Size(104, 24);
			this.chkFloat.TabIndex = 3;
			this.chkFloat.Text = "Allow Float";
			this.chkFloat.CheckedChanged += new System.EventHandler(this.chkFloat_CheckedChanged);
			// 
			// chkInput
			// 
			this.chkInput.Location = new System.Drawing.Point(20, 35);
			this.chkInput.Name = "chkInput";
			this.chkInput.Size = new System.Drawing.Size(104, 24);
			this.chkInput.TabIndex = 2;
			this.chkInput.Text = "Allow All Input";
			this.chkInput.CheckedChanged += new System.EventHandler(this.chkInput_CheckedChanged);
			// 
			// numericTextBox1
			// 
			this.numericTextBox1.Location = new System.Drawing.Point(20, 10);
			this.numericTextBox1.Name = "numericTextBox1";
			this.numericTextBox1.Size = new System.Drawing.Size(100, 20);
			this.numericTextBox1.TabIndex = 0;
			this.numericTextBox1.Text = "50";
			this.numericTextBox1.Value = 50;
			// 
			// tabRecent
			// 
			this.tabRecent.ContextMenuStrip = this.RecentFilesContext;
			this.tabRecent.Controls.Add(this.btnGetRecentFiles);
			this.tabRecent.Controls.Add(this.Files);
			this.tabRecent.Controls.Add(this.btnUpdateRecentFiles);
			this.tabRecent.Location = new System.Drawing.Point(4, 22);
			this.tabRecent.Name = "tabRecent";
			this.tabRecent.Size = new System.Drawing.Size(432, 164);
			this.tabRecent.TabIndex = 4;
			this.tabRecent.Text = "Recent Files";
			// 
			// RecentFilesContext
			// 
			this.RecentFilesContext.Name = "RecentFilesContext";
			this.RecentFilesContext.Size = new System.Drawing.Size(61, 4);
			// 
			// btnGetRecentFiles
			// 
			this.btnGetRecentFiles.Location = new System.Drawing.Point(10, 10);
			this.btnGetRecentFiles.Name = "btnGetRecentFiles";
			this.btnGetRecentFiles.Size = new System.Drawing.Size(60, 23);
			this.btnGetRecentFiles.TabIndex = 3;
			this.btnGetRecentFiles.Text = "&Get";
			this.btnGetRecentFiles.Click += new System.EventHandler(this.btnGetRecentFiles_Click);
			// 
			// Files
			// 
			this.Files.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
						| System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.Files.FileName = "";
			this.Files.Location = new System.Drawing.Point(80, 10);
			this.Files.Name = "Files";
			this.Files.Size = new System.Drawing.Size(345, 145);
			this.Files.TabIndex = 0;
			// 
			// btnUpdateRecentFiles
			// 
			this.btnUpdateRecentFiles.Location = new System.Drawing.Point(10, 40);
			this.btnUpdateRecentFiles.Name = "btnUpdateRecentFiles";
			this.btnUpdateRecentFiles.Size = new System.Drawing.Size(60, 23);
			this.btnUpdateRecentFiles.TabIndex = 1;
			this.btnUpdateRecentFiles.Text = "&Set";
			this.btnUpdateRecentFiles.Click += new System.EventHandler(this.btnUpdateRecentFiles_Click);
			// 
			// tabRichText
			// 
			this.tabRichText.Controls.Add(this.btnTestRichText);
			this.tabRichText.Controls.Add(this.RichText);
			this.tabRichText.Location = new System.Drawing.Point(4, 22);
			this.tabRichText.Name = "tabRichText";
			this.tabRichText.Size = new System.Drawing.Size(432, 164);
			this.tabRichText.TabIndex = 6;
			this.tabRichText.Text = "RichText";
			// 
			// btnTestRichText
			// 
			this.btnTestRichText.Location = new System.Drawing.Point(8, 8);
			this.btnTestRichText.Name = "btnTestRichText";
			this.btnTestRichText.Size = new System.Drawing.Size(75, 23);
			this.btnTestRichText.TabIndex = 1;
			this.btnTestRichText.Text = "&Test";
			this.btnTestRichText.Click += new System.EventHandler(this.btnTestRichText_Click);
			// 
			// RichText
			// 
			this.RichText.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
						| System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.RichText.Location = new System.Drawing.Point(8, 36);
			this.RichText.Name = "RichText";
			this.RichText.Size = new System.Drawing.Size(416, 120);
			this.RichText.TabIndex = 0;
			this.RichText.Tag = "";
			this.RichText.Text = "This is a test.";
			// 
			// txtOutput
			// 
			this.txtOutput.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtOutput.Location = new System.Drawing.Point(0, 190);
			this.txtOutput.Multiline = true;
			this.txtOutput.Name = "txtOutput";
			this.txtOutput.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtOutput.Size = new System.Drawing.Size(440, 249);
			this.txtOutput.TabIndex = 3;
			this.txtOutput.WordWrap = false;
			// 
			// FontDlg
			// 
			this.FontDlg.FontMustExist = true;
			this.FontDlg.ShowColor = true;
			// 
			// FormSave
			// 
			this.FormSave.BaseSettingsPath = "Software\\Menees\\TestMeneesComponents";
			this.FormSave.ContainerControl = this;
			this.FormSave.SaveSettings += new Menees.SettingsEventHandler(this.FormSave_SaveSettings);
			this.FormSave.LoadSettings += new Menees.SettingsEventHandler(this.FormSave_LoadSettings);
			// 
			// RecentFiles
			// 
			this.RecentFiles.ContextMenu = this.RecentFilesContext;
			this.RecentFiles.FormSaver = this.FormSave;
			this.RecentFiles.Items = new string[0];
			this.RecentFiles.MenuItem = this.mnuRecentFiles;
			this.RecentFiles.ItemClick += new Menees.ItemClickEventHandler(this.RecentFiles_FileClick);
			// 
			// mnuRecentFiles
			// 
			this.mnuRecentFiles.Name = "mnuRecentFiles";
			this.mnuRecentFiles.Size = new System.Drawing.Size(152, 22);
			this.mnuRecentFiles.Text = "&Recent Files";
			// 
			// pnlSide
			// 
			this.pnlSide.Controls.Add(this.txtOutput);
			this.pnlSide.Controls.Add(this.PageCtrl);
			this.pnlSide.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlSide.Location = new System.Drawing.Point(0, 24);
			this.pnlSide.Name = "pnlSide";
			this.pnlSide.Size = new System.Drawing.Size(440, 439);
			this.pnlSide.TabIndex = 5;
			// 
			// splitter1
			// 
			this.splitter1.BackColor = System.Drawing.SystemColors.Control;
			this.splitter1.Location = new System.Drawing.Point(440, 24);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 439);
			this.splitter1.TabIndex = 6;
			this.splitter1.TabStop = false;
			// 
			// menuStrip1
			// 
			this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.mnuFile,
            this.mnuHelp});
			this.menuStrip1.Location = new System.Drawing.Point(0, 0);
			this.menuStrip1.Name = "menuStrip1";
			this.menuStrip1.Size = new System.Drawing.Size(662, 24);
			this.menuStrip1.TabIndex = 8;
			this.menuStrip1.Text = "menuStrip1";
			// 
			// mnuFile
			// 
			this.mnuFile.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.mnuRecentFiles,
            this.toolStripMenuItem1,
            this.mnuExit});
			this.mnuFile.Name = "mnuFile";
			this.mnuFile.Size = new System.Drawing.Size(35, 20);
			this.mnuFile.Text = "&File";
			// 
			// toolStripMenuItem1
			// 
			this.toolStripMenuItem1.Name = "toolStripMenuItem1";
			this.toolStripMenuItem1.Size = new System.Drawing.Size(149, 6);
			// 
			// mnuExit
			// 
			this.mnuExit.Name = "mnuExit";
			this.mnuExit.Size = new System.Drawing.Size(152, 22);
			this.mnuExit.Text = "E&xit";
			this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
			// 
			// mnuHelp
			// 
			this.mnuHelp.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.mnuAbout});
			this.mnuHelp.Name = "mnuHelp";
			this.mnuHelp.Size = new System.Drawing.Size(40, 20);
			this.mnuHelp.Text = "&Help";
			// 
			// mnuAbout
			// 
			this.mnuAbout.Name = "mnuAbout";
			this.mnuAbout.Size = new System.Drawing.Size(152, 22);
			this.mnuAbout.Text = "&About...";
			this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.ClientSize = new System.Drawing.Size(662, 463);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.pnlSide);
			this.Controls.Add(this.menuStrip1);
			this.IsMdiContainer = true;
			this.MainMenuStrip = this.menuStrip1;
			this.Name = "MainForm";
			this.Text = "Test Menees Components";
			this.PageCtrl.ResumeLayout(false);
			this.tabEditor.ResumeLayout(false);
			this.tabEditor.PerformLayout();
			this.tabFileName.ResumeLayout(false);
			this.tabFileName.PerformLayout();
			this.tabNumEdit.ResumeLayout(false);
			this.tabNumEdit.PerformLayout();
			this.tabRecent.ResumeLayout(false);
			this.tabRecent.PerformLayout();
			this.tabRichText.ResumeLayout(false);
			this.pnlSide.ResumeLayout(false);
			this.pnlSide.PerformLayout();
			this.menuStrip1.ResumeLayout(false);
			this.menuStrip1.PerformLayout();
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			VisualStyles.EnableApplication();
			Application.Run(new MainForm());
		}

		private void btnFileName_Click(object sender, System.EventArgs e)
		{
			ResetText("*** Test FileName ***");

			FileName FN = new FileName(txtFileName.Text);

			WriteLine("Drive = " + FN.Drive);
			WriteLine("Path = " + FN.Path);
			WriteLine("Name = " + FN.Name);
			WriteLine("Extension = " + FN.Extension);
			WriteLine("NameNoExt = " + FN.NameNoExt);
			WriteLine("FullName = " + FN.FullName);
			WriteLine("operator string = " + FN);
			WriteLine("Exists = " + FN.Exists.ToString());
			WriteLine("FileInfo = " + FN.FileInfo.FullName);

			WriteLine();
			WriteLine("ExpandedName = " + FN.ExpandedName);
			FN.Path = "";
			WriteLine("FullName = " + FN.FullName);
			WriteLine("ExpandedName = " + FN.ExpandedName);

			FN.FullName = FN.ExpandedName;
			FN.Extension = ".exe";
			WriteLine("FullName = " + FN.FullName);
			FN.Name = "XPad.exe";
			WriteLine("FullName = " + FN.FullName);
			WriteLine("Drive = " + FN.Drive);
			WriteLine("Path = " + FN.Path);
			WriteLine("Name = " + FN.Name);
			WriteLine("Extension = " + FN.Extension);

			WriteLine("Relative To Windows Directory: " + FN.GetRelativePath(Environment.GetEnvironmentVariable("WINDIR")));
		}

		private void chkInput_CheckedChanged(object sender, System.EventArgs e)
		{
			numericTextBox1.AllowAllInput = chkInput.Checked;
		}

		private void chkFloat_CheckedChanged(object sender, System.EventArgs e)
		{
			numericTextBox1.AllowFloat = chkFloat.Checked;
		}

		private void chkNegative_CheckedChanged(object sender, System.EventArgs e)
		{
			numericTextBox1.AllowNegative = chkNegative.Checked;
		}

		private void edtMin_Validated(object sender, System.EventArgs e)
		{
			numericTextBox1.MinValue = edtMin.Value;
		}

		private void edtMax_Validated(object sender, System.EventArgs e)
		{
			numericTextBox1.MaxValue = edtMax.Value;
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			Editor.Open();
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			Editor.Save(false);
		}

		private void btnNew_Click(object sender, System.EventArgs e)
		{
			Editor.New();
		}

		private void btnTestTextEditor_Click(object sender, System.EventArgs e)
		{
			ResetText("*** Test TextEditor ***");

			WriteLine("FileName: " + Editor.FileName.ToString());
			WriteLine("Title: " + Editor.Title.ToString());
			WriteLine("CanCut: " + Editor.CanCut.ToString());
			WriteLine("CanCopy: " + Editor.CanCopy.ToString());
			WriteLine("CanPaste: " + Editor.CanPaste.ToString());
			WriteLine("FirstVisibleLine: " + Editor.FirstVisibleLine.ToString());
			WriteLine("LineCount: " + Editor.LineCount.ToString());

			Editor.GotoLine(2, true);
			Editor.CaretPoint = new Point(4, 1);
		}

		private void TestTabWidths()
		{
			ResetText(Editor.Font.ToString());
			int iOrigSpaces = Editor.TabSpaces;
			for (int i = 0; i <= 40; i++)
			{
				Editor.TabSpaces = i;
				ReportTabPixelWidths();
			}
			Editor.TabSpaces = iOrigSpaces;
		}

		private void Editor_CaretMoved(object sender, Menees.CaretMovedEventArgs e)
		{
			lblCaret.Text = (e.CaretPoint.Y+1).ToString() + ", " + (e.CaretPoint.X+1).ToString();
		}

		private void btnFont_Click(object sender, System.EventArgs e)
		{
			FontDlg.Font = Editor.Font;

			if (FontDlg.ShowDialog() == DialogResult.OK)
			{
				Editor.Font = FontDlg.Font;
				
				TestTabWidths();
			}
		}

		private void btnTabs_Click(object sender, System.EventArgs e)
		{
			NumDlg Dlg = new NumDlg();
			Dlg.Text = "Tabs";
			Dlg.NumEdit.Value = Editor.TabSpaces;
			if (Dlg.ShowDialog() == DialogResult.OK)
			{
				Editor.TabSpaces = Dlg.NumEdit.IntValue;
				ReportTabPixelWidths();
			}
		}

		private void ReportTabPixelWidths()
		{
			int iTabWidth = GetPixelWidth("\t");
			int iSpaceWidth = GetPixelWidth(new string(' ', Editor.TabSpaces));
			WriteLine(String.Format("TabSpaces: {2}, SpacePixels: {1}, TabPixels: {0}\t{3} ", iTabWidth, iSpaceWidth, Editor.TabSpaces, iTabWidth == iSpaceWidth || Editor.TabSpaces == 0 ? "" : "*** INCORRECT ***"));
		}

		private int GetPixelWidth(string strText)
		{
			Editor.Focus();

			//Make sure we start at the beginning of a line
			//so tabs don't get truncated.
			Editor.SelectionStart = 0;
			Editor.SelectionLength = 0;

			Point ptStart = new Point();
			Windows.GetCaretPos(ref ptStart);
			Editor.SelectedText = strText;
			Point ptEnd = new Point();
			Windows.GetCaretPos(ref ptEnd);

			Editor.SelectionStart -= strText.Length;
			Editor.SelectionLength = strText.Length;
			Editor.SelectedText = "";

			return ptEnd.X - ptStart.X;
		}

		private void FormSave_LoadSettings(object sender, Menees.SettingsEventArgs e)
		{
			PageCtrl.SelectedIndex = e.SettingsKey.GetInt("CurrentTab", PageCtrl.SelectedIndex);
		}

		private void FormSave_SaveSettings(object sender, Menees.SettingsEventArgs e)
		{
			e.SettingsKey.SetInt("CurrentTab", PageCtrl.SelectedIndex);
		}

		private void RecentFiles_FileClick(object sender, Menees.ItemClickEventArgs e)
		{
			MessageBox.Show(e.ItemName);
		}

		private void btnUpdateRecentFiles_Click(object sender, System.EventArgs e)
		{
			RecentFiles.Items = Files.Lines;
		}

		private void btnGetRecentFiles_Click(object sender, System.EventArgs e)
		{
			Files.Lines = RecentFiles.Items;
		}

		private void mnuExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void btnTestRichText_Click(object sender, System.EventArgs e)
		{
			using (WaitCursor WC = new WaitCursor(this))
			{
				//For testing WaitCursor.
				//System.Threading.Thread.Sleep(5000);

				ResetText("Test RichTextBoxEx");

				WriteLine("CanUndo: " + RichText.CanUndo);
				WriteLine("Text: " + RichText.Text);
				WriteLine("TextLength: " + RichText.TextLength.ToString());
				WriteLine("SelectedText: " + RichText.SelectedText.ToString());
				WriteLine("SelectionLength: " + RichText.SelectionLength.ToString());
				WriteLine("CanUndo: " + RichText.CanUndo);
			}
		}

		private void mnuAbout_Click(object sender, EventArgs e)
		{
			Utilities.About(this, "Test Menees", Utilities.GetCallingAssemblyVersion());
		}
	}
}
